1218. Longest Arithmetic Subsequence of Given Difference
Given an integer array arr
and an integer difference
, return the length of the longest subsequence in arr
which is an arithmetic sequence such that the difference between adjacent elements in the subsequence equals difference
.
A subsequence is a sequence that can be derived from arr
by deleting some or no elements without changing the order of the remaining elements.
Example 1:
Input: arr = [1,2,3,4], difference = 1
Output:
Explanation: The longest arithmetic subsequence is [1,2,3,4]
.
Example 2:
Input: arr = [1,3,5,7], difference = 1
Output:
Explanation: The longest arithmetic subsequence is any single element.
Example 3:
Input: arr = [1,5,7,8,5,3,4,2,1], difference = -2
Output:
Explanation: The longest arithmetic subsequence is [7,5,3,1]
.
Constraints:
-
arr.length
-
arr[i], difference
Solution
Brute Force
For this problem, let's think of building the subsequence one integer at a time. If our subsequence is currently ending with the integer , our next integer will have to be difference
. Since subsequences must follow the relative order of the original array, we want to pick the next closest value of difference
and append it to our subsequence. We can also observe that appending the closest value of difference
will give us more options for the next addition to our subsequence.
To find the longest subsequence however, we can try all possible starting positions for our subsequence and construct it greedily with the method mentioned above. Out of all subsequences, we'll return the length of the longest one.
Example
For this example, we'll start the sequence at index and difference
is .
Our subsequence starts with and we're looking for difference
. It appears at indices and . We want the next closest position so we'll pick the at index . We apply the same idea to then pick at index and finally at index .
Let represent arr.length
.
Since building the subsequence takes and we build subsequences (one for each starting position), this algorithm runs in .
Full Solution
For a faster solution, we'll use dynamic programming. We know that to extend subsequence ending with , we'll find the next closest element with value difference
and add it into our subsequence. We can also think of this idea from the other direction. To find the subsequence ending with difference
at some position, we'll look for the previous closest element . Then, we'll take the longest subsequence ending with that specific element and append difference
to obtain our desired subsequence. This idea uses solutions from sub-problems to solve a larger problem, which is essentially dynamic programming.
Let dp[i]
represent the length of the longest subsequence with the last element at index .
Let j
represent the previous closest index of the value arr[i] - difference
. If j
exists, then dp[i] = dp[j] + 1
since we take the longest subsequence ending at index j
and append arr[i]
to it. Otherwise, our subsequence is just arr[i]
itself so dp[i] = 1
.
We can maintain the previous closest index of integers with a hashmap. The hashmap will use a key for the integer and the value will be the closest index of that integer. Everytime we process dp[i]
for some index , we'll update arr[i]
into our hashmap. Our final answer is the maximum value among all values in dp
.
Time Complexity
Since we take to calculate dp[i]
for one index , our time complexity is since dp
has a length of .
Time Complexity:
Space Complexity
Our dp
array and hashmap both use memory so our space complexity is .
Space Complexity:
C++ Solution
class Solution {
public:
int longestSubsequence(vector<int>& arr, int difference) {
int n = arr.size();
unordered_map<int, int> prevIndex; // keeps track of closest index of integer
vector<int> dp(n);
int ans = 0;
for (int i = 0; i < n; i++) {
int prevNum = arr[i] - difference;
if (prevIndex.count(prevNum)) { // checks if prevNum was processed
dp[i] = dp[prevIndex[prevNum]] + 1;
} else {
dp[i] = 1;
}
prevIndex[arr[i]] = i; // the closest previous index of arr[i] is always i at this point
ans = max(ans, dp[i]);
}
return ans;
}
};
Java Solution
class Solution {
public int longestSubsequence(int[] arr, int difference) {
int n = arr.length;
HashMap<Integer, Integer> prevIndex = new HashMap(); // keeps track of closest index of integer
int[] dp = new int[n];
int ans = 0;
for (int i = 0; i < n; i++) {
int prevNum = arr[i] - difference;
if (prevIndex.containsKey(prevNum)) { // checks if prevNum was processed
dp[i] = dp[prevIndex.get(prevNum)] + 1;
} else {
dp[i] = 1;
}
prevIndex.put(arr[i], i); // the closest previous index of arr[i] is always i at this point
ans = Math.max(ans, dp[i]);
}
return ans;
}
}
Python Solution
class Solution:
def longestSubsequence(self, arr: List[int], difference: int) -> int:
n = len(arr)
prevIndex = {} # keeps track of closest index of integer
dp = [0] * n
ans = 0
for i in range(n):
prevNum = arr[i] - difference
if prevNum in prevIndex: # checks if prevNum was processed
dp[i] = dp[prevIndex[prevNum]] + 1
else:
dp[i] = 1
prevIndex[arr[i]] = i # the closest previous index of arr[i] is always i at this point
ans = max(ans, dp[i])
return ans
Ready to land your dream job?
Unlock your dream job with a 2-minute evaluator for a personalized learning plan!
Start EvaluatorWhat's the output of running the following function using input 56
?
1KEYBOARD = {
2 '2': 'abc',
3 '3': 'def',
4 '4': 'ghi',
5 '5': 'jkl',
6 '6': 'mno',
7 '7': 'pqrs',
8 '8': 'tuv',
9 '9': 'wxyz',
10}
11
12def letter_combinations_of_phone_number(digits):
13 def dfs(path, res):
14 if len(path) == len(digits):
15 res.append(''.join(path))
16 return
17
18 next_number = digits[len(path)]
19 for letter in KEYBOARD[next_number]:
20 path.append(letter)
21 dfs(path, res)
22 path.pop()
23
24 res = []
25 dfs([], res)
26 return res
27
1private static final Map<Character, char[]> KEYBOARD = Map.of(
2 '2', "abc".toCharArray(),
3 '3', "def".toCharArray(),
4 '4', "ghi".toCharArray(),
5 '5', "jkl".toCharArray(),
6 '6', "mno".toCharArray(),
7 '7', "pqrs".toCharArray(),
8 '8', "tuv".toCharArray(),
9 '9', "wxyz".toCharArray()
10);
11
12public static List<String> letterCombinationsOfPhoneNumber(String digits) {
13 List<String> res = new ArrayList<>();
14 dfs(new StringBuilder(), res, digits.toCharArray());
15 return res;
16}
17
18private static void dfs(StringBuilder path, List<String> res, char[] digits) {
19 if (path.length() == digits.length) {
20 res.add(path.toString());
21 return;
22 }
23 char next_digit = digits[path.length()];
24 for (char letter : KEYBOARD.get(next_digit)) {
25 path.append(letter);
26 dfs(path, res, digits);
27 path.deleteCharAt(path.length() - 1);
28 }
29}
30
1const KEYBOARD = {
2 '2': 'abc',
3 '3': 'def',
4 '4': 'ghi',
5 '5': 'jkl',
6 '6': 'mno',
7 '7': 'pqrs',
8 '8': 'tuv',
9 '9': 'wxyz',
10}
11
12function letter_combinations_of_phone_number(digits) {
13 let res = [];
14 dfs(digits, [], res);
15 return res;
16}
17
18function dfs(digits, path, res) {
19 if (path.length === digits.length) {
20 res.push(path.join(''));
21 return;
22 }
23 let next_number = digits.charAt(path.length);
24 for (let letter of KEYBOARD[next_number]) {
25 path.push(letter);
26 dfs(digits, path, res);
27 path.pop();
28 }
29}
30
Recommended Readings
LeetCode Patterns Your Personal Dijkstra's Algorithm to Landing Your Dream Job The goal of AlgoMonster is to help you get a job in the shortest amount of time possible in a data driven way We compiled datasets of tech interview problems and broke them down by patterns This way we
Recursion Recursion is one of the most important concepts in computer science Simply speaking recursion is the process of a function calling itself Using a real life analogy imagine a scenario where you invite your friends to lunch https algomonster s3 us east 2 amazonaws com recursion jpg You first
Runtime Overview When learning about algorithms and data structures you'll frequently encounter the term time complexity This concept is fundamental in computer science and offers insights into how long an algorithm takes to complete given a certain input size What is Time Complexity Time complexity represents the amount of time
Want a Structured Path to Master System Design Too? Don’t Miss This!